Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
Bee

Open Nhiều File Với C# ?

Các bài được khuyến nghị

Bee    108

Room lisp dạo này thấy xôm xôm rồi. Sang đây chơi vậy.

 

Mọi người cho hỏi có code share, ví dụ : open lần lượt từng file dwg trong folder select rồi vẽ 1 line trong từng file không ạ ?

 

Nếu có thì chỉ cách cho mình nghiên cứu với :)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
gia_bach    1.442

Room lisp dạo này thấy xôm xôm rồi. Sang đây chơi vậy.

 

Mọi người cho hỏi có code share, ví dụ : open lần lượt từng file dwg trong folder select rồi vẽ 1 line trong từng file không ạ ?

 

Nếu có thì chỉ cách cho mình nghiên cứu với :)

Tham khảo nhé : 

- nếu muốn chọn folder thì dùng OpenFileDialog hoặc FolderBrowserDialog

        [CommandMethod("AddLineToAllFolder", CommandFlags.Session)]
        public static void AddLineToAllFolder()
        {
            try
            {
                string folder = @"C:\Temp\";
                foreach (string dwg in System.IO.Directory.EnumerateFiles(folder, "*.dwg"))
                {
                    Document doc = Application.DocumentManager.Open(dwg, false);
                    using (doc.LockDocument())
                    using (Transaction tr = doc.TransactionManager.StartTransaction())
                    {
                        BlockTable bt = (BlockTable)tr.GetObject(doc.Database.BlockTableId, OpenMode.ForRead);
                        BlockTableRecord ms = (BlockTableRecord)tr.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite);
                        Line line = new Line(Point3d.Origin, new Point3d(1, 1, 1));
                        ms.AppendEntity(line);
                        tr.AddNewlyCreatedDBObject(line, true);
                        tr.Commit();
                    }
                    doc.CloseAndSave(dwg);
                }
            }
            catch (System.Exception e)
            {
                Application.ShowAlertDialog("Something went wrong\n" + e.ToString());
            }
        }

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Bee    108

 

Tham khảo nhé : 

- nếu muốn chọn folder thì dùng OpenFileDialog hoặc FolderBrowserDialog

        [CommandMethod("AddLineToAllFolder", CommandFlags.Session)]
        public static void AddLineToAllFolder()
        {
            try
            {
                string folder = @"C:\Temp\";
                foreach (string dwg in System.IO.Directory.EnumerateFiles(folder, "*.dwg"))
                {
                    Document doc = Application.DocumentManager.Open(dwg, false);
                    using (doc.LockDocument())
                    using (Transaction tr = doc.TransactionManager.StartTransaction())
                    {
                        BlockTable bt = (BlockTable)tr.GetObject(doc.Database.BlockTableId, OpenMode.ForRead);
                        BlockTableRecord ms = (BlockTableRecord)tr.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite);
                        Line line = new Line(Point3d.Origin, new Point3d(1, 1, 1));
                        ms.AppendEntity(line);
                        tr.AddNewlyCreatedDBObject(line, true);
                        tr.Commit();
                    }
                    doc.CloseAndSave(dwg);
                }
            }
            catch (System.Exception e)
            {
                Application.ShowAlertDialog("Something went wrong\n" + e.ToString());
            }
        }

Ok thanks Gia bach. Room này không xôm nên lâu lâu mới vào check. heizz

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×